/*
 * lab1.c
 */
#include <avr/io.h>			/* Include AVR std. library file */
#include <util/delay.h>			/* Include Delay header file */
#include <stdio.h>			/* Include standard IO library */
#include <string.h>
#include <stdlib.h>			/* Include standard library */
#include <avr/interrupt.h>		/* Include avr interrupt header file */
#include "usart.h"		/* Include header file */
#include "lcd.h"

#define SSID				"iPhone - Alexandru"
#define PASSWORD			"salutare"

// 1 daca am primit comenzi
static int recv_alert = 0;
// size-ul bufferului
static int gl_size = 398;
// buffer in care salvez mesajele primite de la modulul wireless
static char gl_answer[400];
// var care marcheaza finalul mesajului primit
static int gl_end = 0;
static char cx;

// 1 daca sunt avariile pornite, 0 daca sunt oprite
static int avarii_pornite = 0;
// 1 daca masina se afa in miscare, 0 daca sta pe loc
static int moving = 0;
// 1 daca masina ia un viraj, 0 altfel
static int drifting = 0;
static int direction = -1; // 0 = viraj stanga, 1 = viraj dreapta
// factorul vechi de umplere al motorului pana sa ia virajul
static int saved = 0;

// folosit de catre driverul de motoare
void timer0_init()
{
	// Fast PWM cu top la 0xFF, prescaler de 1, output atat pe canalul A cat si pe B, reset on compare
	OCR0A = 0;
	OCR0B = 0;
	TCCR0A |= (1 << COM0A1) | (1 << COM0B1) | (1 << WGM01) | (1 << WGM00);
	TCCR0B |= (1 << CS00);
}

// folosit pentru semnalizari
void timer1_init()
{
	// FRECVENTA 2HZ, semnal si pe canalul A si pe canalul B pentru fiecare semnalizare
	ICR1 = 31250;
	OCR1A = ICR1 + 1;
	OCR1B = ICR1 + 1;
	// CTC cu top la ICR1
	TCCR1B |= (1 << WGM13) | (1 << WGM12) | (1 << CS12);
	// enable la intreruperi
	TIMSK1 |= (1 << OCIE1B) | (1 << OCIE1A);
}

// folosit de buzzer
void timer2_init()
{
	// Fast PWM cu top la 0xFF, prescaler 128
	OCR2B = 255;
	TCCR2A |= (1 << COM2B1) | (1 << WGM20) | (1 << WGM21);
	TCCR2B |= (1 << CS22) | (1 << CS20);
}

void buzzer_init()
{
	DDRD |= (1 << PD6);
	PORTD |= (1 << PD6);
	timer2_init();
}

void signals_init()
{
	DDRC |= (1 << PC0) | (1 << PC2);
	PORTC &= ~(1 << PC0);
	PORTC &= ~(1 << PC2);
	timer1_init();	
}

void process_request()
{
	cli();
	gl_answer[gl_end] = '\0';
	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_print(gl_answer);
	if (strstr(gl_answer, "lumini")) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("lumini");
		PORTC ^= (1 << PC1);
	} else if (strstr(gl_answer, "sem_st")) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("sem_st");		
		if (avarii_pornite == 1)
			goto finish;		
		// daca semnalizarea era oprita		
		if (OCR1A == ICR1 + 1) {
			TCNT1 = 0;
			// opresc semnalizarea dreapta
			OCR1B = ICR1 + 1;
			// pornesc semnalizarea stanga			
			OCR1A = ICR1 / 2;
		}
		else {
			// altfel opresc semnalizarea
			TCNT1 = 0;
			OCR1A = ICR1 + 1;
		}
		PORTC &= ~(1 << PC0);
		PORTC &= ~(1 << PC2);
	} else if (strstr(gl_answer, "sem_dr")) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("sem_dr");
		if (avarii_pornite == 1)
			goto finish;		
		// daca semnalizarea era oprita			
		if (OCR1B == ICR1 + 1) {
			// opresc semnalizrea stanga
			TCNT1 = 0;
			OCR1A = ICR1 + 1;
			// pornesc semnalizarea dreapta
			OCR1B = ICR1 / 2;
		}
		else {
			// altfel opresc semnalizarea
			TCNT1 = 0;
			OCR1B = ICR1 + 1;
		}
		PORTC &= ~(1 << PC0);
		PORTC &= ~(1 << PC2);
	} else if (strstr(gl_answer, "claxon")) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("claxon");
		OCR2B = 255 + 128 - OCR2B;
	} else if (strstr(gl_answer, "avarii")) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("avarii");		
		if (avarii_pornite) {
			TCNT1 = 0;
			OCR1A = ICR1 + 1;
			OCR1B = ICR1 + 1;
		} else {
			TCNT1 = 0;
			OCR1A = ICR1 / 2;
			OCR1B = ICR1 / 2;
		}
		// si daca erau pornite si daca le-am, oprit, le sting pentru sincronizare
		PORTC &= ~(1 << PC0);
		PORTC &= ~(1 << PC2);
		avarii_pornite = 1 - avarii_pornite;
	} else if (strstr(gl_answer, "inainte")) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("inainte");
		// daca ma aflu in viraj nu fac nimic, altfel setez viteza minima si directia inapoi
		if (drifting)
			goto finish;
		PORTA &= ~(1 << PA0);
		PORTA &= ~(1 << PA1);
		OCR0A = 128;
		OCR0B = 128;
		moving = 1;
	} else if (strstr(gl_answer, "inapoi")) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("inapoi");
		// daca ma aflu in viraj nu fac nimic, altfel setez viteza minima si directia inainte		
		if (drifting)
			goto finish;		
		PORTA |= 1 << PA0;
		PORTA |= 1 << PA1;
		OCR0A = 128;
		OCR0B = 128;
		moving = 1;
	} else if (strstr(gl_answer, "stop")) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("stop");
		// opresc ambele motoare;
		PORTA &= ~(1 << PA0);
		PORTA &= ~(1 << PA1);
		OCR0A = 0;
		OCR0B = 0;
		moving = 0;
		drifting = 0;
	}
	else if (strstr(gl_answer, "stanga")) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("stanga");
		// daca masina nu se afla in miscare, nu fac nimic		
		if (moving == 0)
			goto finish;
		// incep virajul, salvez vechea valoare la OCR-ului si directia in care se face virajul
		if (drifting == 0) {
			saved = OCR0B;
			OCR0B /= 2;
			drifting = 1;
			direction = 0;
		} else {
			// daca virajul nu a fost inceput in aceasta directie, nu fac nimic
			if (direction != 0)
				goto finish;
			// opresc virajul, refac valoarea OCR-ului
			OCR0B = saved;
			drifting = 0;
			direction = -1;
		}
	}
	else if (strstr(gl_answer, "dreapta")) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("dreapta");
		// analog ca mai sus, doar ca pe dos
		if (moving == 0)
			goto finish;		
		if (drifting == 0) {
			saved = OCR0A;
			OCR0A /= 2;
			drifting = 1;
			direction = 1;
		} else {
			if (direction != 1)
				goto finish;
			OCR0A = saved;
			drifting = 0;
			direction = -1;
		}
	} else if (strstr(gl_answer, "shiftup")) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("shiftup");
		if (moving == 0) 
			goto finish;
		// daca merg drept
		if (drifting == 0) {
			// doar maresc viteza
			if (OCR0A == 255)
				goto finish;
			else {
				OCR0A += OCR0A == 224 ? 31 : 32;
				OCR0B = OCR0A;
			}
		} else {
			// altfel verific in ce directie ma deplasez, maresc viteza pe motorul opus si actualizez pe motorul celalalt
			if (direction == 0) {
				if (OCR0A == 255)
					goto finish;
				else {
					OCR0A += OCR0A == 224 ? 31 : 32;
					OCR0B = OCR0A / 2;
					saved = OCR0A;
				}
			} else {
				if (OCR0B == 255)
					goto finish;
				else {
					OCR0B += OCR0B == 224 ? 31 : 32;
					OCR0A = OCR0B / 2;
					saved = OCR0B;
				}
			}
		}
	} else if (strstr(gl_answer, "shiftdown")) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("shiftdown");		
		// daca merg drept
		if (moving == 0) 
			goto finish;
		if (drifting == 0) {
			// doar maresc viteza
			if (OCR0A <= 128)
				goto finish;
			else {
				OCR0A -= OCR0A == 255 ? 31 : 32;
				OCR0B = OCR0A;
			}
		} else {
			// altfel verific in ce directie ma deplasez, maresc viteza pe motorul opus si actualizez pe motorul celalalt
			if (direction == 0) {
				if (OCR0A <= 128)
					goto finish;
				else {
					OCR0A -= OCR0A == 255 ? 31 : 32;
					OCR0B = OCR0A / 2;
					saved = OCR0A;
				}
			} else {
				if (OCR0B <= 128)
					goto finish;
				else {
					OCR0B -= OCR0B == 255 ? 31 : 32;
					OCR0A = OCR0B / 2;
					saved = OCR0B;
				}
			}
		}
	}	

finish:
	gl_end = 0;
	sei();
}

void motor_driver_init()
{
	DDRB |= (1 << PB3) | (1 << PB4);
	DDRA |= (1 << PA0) | (1 << PA1);
	PORTA &= ~(1 << PA0);
	PORTA &= ~(1 << PA1);
	timer0_init();
}

void lights_init() {
	DDRC |= (1 << PC1);
	PORTC &= ~(1 << PC1);
}

ISR(USART0_RX_vect) {
	
	cx = UDR0;		
	
	// Setez alerta de receive
	recv_alert = 1;
	
	// Retin caracterele primite de la modul, bufferul se goleste cand se fac citiri dinel
	if (gl_end < gl_size) {
		gl_answer[gl_end++] = cx;
		gl_answer[gl_end] = '\0';
	}
}

// toggle la semnalizarea dreapta
ISR(TIMER1_COMPA_vect) {
	PORTC ^= (1 << PC2);	
}

// toggle la semnalizarea stanga
ISR(TIMER1_COMPB_vect) {
	PORTC ^= (1 << PC0);
}

// functia initializeaza modulul wireless, incercand fiecare intructiune de maxim tries ori
int initialize_wifi(unsigned int tries) {
	unsigned int i;
	// Resetez wifi - este necesar un delay pt ca dureaza pana se reseteaza
	for (i = 0; i < tries; ++i) {	
		gl_end = 0;
		USART0_print("AT+RST\r\n");
		_delay_ms(1000);
		gl_answer[gl_end] = '\0';
		if (strstr(gl_answer, "OK"))
			break;
	}
	if (i >= tries)
		return 0;
	
	// Schimb modul de rulare ca station
	for (i = 0; i < tries; ++i) {	
		gl_end = 0;
		USART0_print("AT+CWMODE_CUR=3\r\n");
		_delay_ms(1000);
		gl_answer[gl_end] = '\0';
		if (strstr(gl_answer, "OK"))
			break;
	}
	if (i >= tries)
		return 0;

	for (i = 0; i < tries; ++i) {
		gl_end = 0;
		USART0_print("AT+CIPMODE=0\r\n");
		_delay_ms(1000);
		gl_answer[gl_end] = '\0';
		if (strstr(gl_answer, "OK"))
			break;
	}
	if (i >= tries)
		return 0;

	// Multi conexiune
	for (i = 0; i < tries; ++i) {
		gl_end = 0;
		USART0_print("AT+CIPMUX=1\r\n");
		_delay_ms(1000);
		gl_answer[gl_end] = '\0';
		if (strstr(gl_answer, "OK"))
			break;
	}
	if (i >= tries)
		return 0;

	// Conectare la AP
	for (i = 0; i < tries; ++i) {	
		gl_end = 0;
		USART0_print("AT+CWJAP=\"iPhone - Alexandru\",\"salutare\"\r\n");
		_delay_ms(5000);
		gl_answer[gl_end] = '\0';
		if (strstr(gl_answer, "OK"))
			break;
	}
	if (i >= tries)
		return 0;
	
	//Setez ca server care asculta pe port 1001
	for (i = 0; i < tries; ++i) {	
		gl_end = 0;
		USART0_print("AT+CIPSERVER=1,1001\r\n");
		_delay_ms(5000);
		gl_answer[gl_end] = '\0';
		if (strstr(gl_answer, "OK"))
			break;
	}
	if (i >= tries)
		return 0;
	

	for (i = 0; i < tries; ++i) {	
		gl_end = 0;
		USART0_print("AT+CIPSTA?\r\n");
		_delay_ms(1000);
		gl_answer[gl_end] = '\0';
		if (strstr(gl_answer, "OK"))
			break;
	}
	if (i >= tries)
		return 0;
	char *p = strstr(gl_answer, "ip:\"");
	if (p) {
		p += 4;
		p[16] = '\0';
		char *finish = strchr(p, '"');
		finish[0] = '\0';
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print(p);
	}
	
	// SUCCES	
	return 1;
}

int main()
{
	sei();
	// ledul conectat la PD7 se aprinde in momentul in care avem conexiune la internet
	DDRD |= (1 << PD7);
	LCD_init();	
	motor_driver_init();
	buzzer_init();	
	lights_init();
	signals_init();
	USART0_init();
	int ok = 0;
	while(ok == 0) {		
		if (initialize_wifi(5) == 1) {
			ok = 1;
		}
	}
	PORTD |= (1 << PD7);
	recv_alert = 0;
	gl_end = 0;
    	while (1) {
		_delay_ms(100);
		if (recv_alert == 1) {
			process_request();
			recv_alert = 0;
		}
	}

    	return 0;
}

